#include "plot.h"

Plot::Plot()
{
        valmin=10;
        valmax=-10;
}


///////////////////////////////////////
// Initialisation des valeurs dans le cas de moteurs
void Plot::Init_Motors()
{
     pointsAAfficher=1976; // points a afficher

    // Disable polygon clipping
    QwtPainter::setDeviceClipping(false);

    // We don't need the cache here
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintCached, false);
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintPacked, false);

#ifdef Q_WS_X11
    canvas()->setAttribute(Qt::WA_PaintOnScreen, true);
#endif

    // Assign a title
//    setTitle("Graphique");
    insertLegend(new QwtLegend(), QwtPlot::BottomLegend);

    alignScales();

    // tableau contenant les valeurs
    val1 = NULL; // 0%
    val2 = NULL; // 10%
    val3 = NULL; // inconnu
    val4 = NULL; // 20%
    val5 = NULL; // A 
    val6 = NULL; // B
    val7 = NULL; // C
    val8 = NULL; // D
    val9 = NULL; // background
    val10 = NULL; // cuve vide
    val11 = NULL; // A - ccl4
    val12 = NULL; // B - ccl4
    val13 = NULL; // C - ccl4
    val14 = NULL; // D - ccl4
    xPoints = NULL;

    marqueur1 = NULL;
    marqueur2 = NULL;
    marqueur3 = NULL;
    marqueur4 = NULL;
    marqueur5 = NULL;
    marqueur6 = NULL;
    marqueur7 = NULL;
    marqueur8 = NULL;
    marqueur9 = NULL;
    marqueur10 = NULL;
    marqueur11 = NULL;
    marqueur12 = NULL;
    marqueur13 = NULL;
    marqueur14 = NULL;
    marqueur15 = NULL;
    marqueur16 = NULL;
    marqueur17 = NULL;
    marqueur18 = NULL;
    marqueur19 = NULL;


    // Axis titles
    setAxisTitle(QwtPlot::xBottom, "Nombre d'onde (cm-1)"); // titre de l'axe des X
    setAxisScale(QwtPlot::xBottom, 4400, 450);
    setAxisScaleEngine(QwtPlot::xBottom, new QwtLog10ScaleEngine);

    setAxisTitle(QwtPlot::yLeft, "A ou T"); // permet de mettre un titre a l'axe des Y
    setAxisScale(QwtPlot::yLeft, -10, 10);

}


void Plot::videPlot()
{
    // On libere la memoire des tableaux
    if (val1 != NULL)
    {
            delete val1; 
            delete val2; 
            delete val3; 
            delete val4; 
            delete val5; 
            delete val6; 
            delete val7; 
            delete val8; 
            delete val9; 
            delete val10; 
            delete val11; 
            delete val12; 
            delete val13; 
            delete val14; 

            delete xPoints;

            delete courbe1; 
            delete courbe2;
            delete courbe3;
            delete courbe4;
            delete courbe5;
            delete courbe6;
            delete courbe7;
            delete courbe8;
            delete courbe9;
            delete courbe10;
            delete courbe11;
            delete courbe12;
            delete courbe13;
            delete courbe14;

            val1 = NULL; 
            val2 = NULL; 
            val3 = NULL; 
            val4 = NULL; 
            val5 = NULL; 
            val6 = NULL; 
            val7 = NULL; 
            val8 = NULL; 
            val9 = NULL; 
            val10 = NULL; 
            val11 = NULL; 
            val12 = NULL; 
            val13 = NULL; 
            val14 = NULL; 
            xPoints = NULL;

            courbe1 = NULL; 
            courbe2 = NULL; 
            courbe3 = NULL; 
            courbe4 = NULL; 
            courbe5 = NULL; 
            courbe6 = NULL; 
            courbe7 = NULL; 
            courbe8 = NULL; 
            courbe9 = NULL; 
            courbe10 = NULL; 
            courbe11 = NULL; 
            courbe12 = NULL; 
            courbe13 = NULL; 
            courbe14 = NULL; 

      }

}


//////////////////////////////////////////////////
// remplir l'echelle des abscisses
void Plot::abscisse(void)
{

    if (val1 == NULL)
    {
            // Creation des tableaux qui vont stocker les valeurs
            val1 = new double[pointsAAfficher];
            val2 = new double[pointsAAfficher];
            val3 = new double[pointsAAfficher];
            val4 = new double[pointsAAfficher];
            val5 = new double[pointsAAfficher];
            val6 = new double[pointsAAfficher];
            val7 = new double[pointsAAfficher];
            val8 = new double[pointsAAfficher];
            val9 = new double[pointsAAfficher];
            val10 = new double[pointsAAfficher];
            val11 = new double[pointsAAfficher];
            val12 = new double[pointsAAfficher];
            val13 = new double[pointsAAfficher];
            val14 = new double[pointsAAfficher];

            xPoints = new double[pointsAAfficher];

        // on vide les tableaux
         for( int i=0; i<pointsAAfficher; i++ )
         {
            xPoints[i] = 4400-2*i;
            val1[i] = 0;
            val2[i] = 0;
            val3[i] = 0;
            val4[i] = 0;
            val5[i] = 0;
            val6[i] = 0;
            val7[i] = 0;
            val8[i] = 0;
            val9[i] = 0;
            val10[i] = 0;
            val11[i] = 0;
            val12[i] = 0;
            val13[i] = 0;
            val14[i] = 0;
         }

        // Insert new curves
        courbe1 = new QwtPlotCurve("0%");
        courbe2 = new QwtPlotCurve("10%");
        courbe3 = new QwtPlotCurve("% inconnu et Background");
        courbe4 = new QwtPlotCurve("20%");
        courbe5 = new QwtPlotCurve("A");
        courbe6 = new QwtPlotCurve("B");
        courbe7 = new QwtPlotCurve("C");
        courbe8 = new QwtPlotCurve("D");
        courbe9 = new QwtPlotCurve("Background");
        courbe10 = new QwtPlotCurve("Cuve vide");
        courbe11 = new QwtPlotCurve("A - CCL4");
        courbe12 = new QwtPlotCurve("B - CCL4");
        courbe13 = new QwtPlotCurve("C - CCL4");
        courbe14 = new QwtPlotCurve("D - CCL4");

        courbe1->attach(this);
        courbe2->attach(this);
        courbe3->attach(this);
        courbe4->attach(this);
        courbe5->attach(this);
        courbe6->attach(this);
        courbe7->attach(this);
        courbe8->attach(this);
        courbe9->attach(this);
        courbe10->attach(this);
        courbe11->attach(this);
        courbe12->attach(this);
        courbe13->attach(this);
        courbe14->attach(this);


// blue, magenta, red, gray, yellow
        // Set curve styles
        courbe1->setPen(QPen(Qt::red));
        courbe2->setPen(QPen(Qt::black));
        courbe3->setPen(QPen(Qt::black));
        courbe4->setPen(QPen(Qt::black));
        courbe5->setPen(QPen(Qt::black));
        courbe6->setPen(QPen(Qt::black));
        courbe7->setPen(QPen(Qt::black));
        courbe8->setPen(QPen(Qt::black));
        courbe9->setPen(QPen(Qt::black));
        courbe10->setPen(QPen(Qt::black));
        courbe11->setPen(QPen(Qt::black));
        courbe12->setPen(QPen(Qt::black));
        courbe13->setPen(QPen(Qt::black));
        courbe14->setPen(QPen(Qt::black));

        // courbe 0% est differente
        QwtSymbol sym;
        sym.setStyle(QwtSymbol::Cross);
        sym.setPen(QColor(Qt::darkRed));
        sym.setSize(2);
        courbe1->setSymbol(sym);
        courbe1->setStyle(QwtPlotCurve::Lines);



        courbe5->setRenderHint(QwtPlotItem::RenderAntialiased); // un peu plus gras A
        courbe6->setRenderHint(QwtPlotItem::RenderAntialiased); // un peu plus gras B
        courbe7->setRenderHint(QwtPlotItem::RenderAntialiased); // un peu plus gras C
        courbe8->setRenderHint(QwtPlotItem::RenderAntialiased); // un peu plus gras D
        courbe11->setRenderHint(QwtPlotItem::RenderAntialiased); // un peu plus gras A
        courbe12->setRenderHint(QwtPlotItem::RenderAntialiased); // un peu plus gras B
        courbe13->setRenderHint(QwtPlotItem::RenderAntialiased); // un peu plus gras C
        courbe14->setRenderHint(QwtPlotItem::RenderAntialiased); // un peu plus gras D

        // on demande a ce que la courbe ne s'affiche pas
        courbe1->setVisible(false);
        courbe2->setVisible(false);
        courbe3->setVisible(false);
        courbe4->setVisible(false);
        courbe5->setVisible(false);
        courbe6->setVisible(false);     
        courbe7->setVisible(false);
        courbe8->setVisible(false);
        courbe9->setVisible(false);
        courbe10->setVisible(false);
        courbe11->setVisible(false);
        courbe12->setVisible(false);
        courbe13->setVisible(false);
        courbe14->setVisible(false);

        // Attach (don't copy) data. Both curves use the same x array.
        courbe1->setRawData(xPoints, val1, pointsAAfficher);
        courbe2->setRawData(xPoints, val2, pointsAAfficher);
        courbe3->setRawData(xPoints, val3, pointsAAfficher);
        courbe4->setRawData(xPoints, val4, pointsAAfficher);
        courbe5->setRawData(xPoints, val5, pointsAAfficher);
        courbe6->setRawData(xPoints, val6, pointsAAfficher);
        courbe7->setRawData(xPoints, val7, pointsAAfficher);
        courbe8->setRawData(xPoints, val8, pointsAAfficher);
        courbe9->setRawData(xPoints, val9, pointsAAfficher);
        courbe10->setRawData(xPoints, val10, pointsAAfficher);
        courbe11->setRawData(xPoints, val11, pointsAAfficher);
        courbe12->setRawData(xPoints, val12, pointsAAfficher);
        courbe13->setRawData(xPoints, val13, pointsAAfficher);
        courbe14->setRawData(xPoints, val14, pointsAAfficher);

        // on met le cadre aux bonnes dimensions 
        setAxisScale(QwtPlot::yLeft, -10, 10);

    }

}


//////////////////////
//  Mise en forme de la fenetre avec bon repositionnement des elements
void Plot::alignScales()
{
    // The code below shows how to align the scales to
    // the canvas frame, but is also a good example demonstrating
    // why the spreaded API needs polishing.

    canvas()->setFrameStyle(QFrame::Box | QFrame::Plain );
    canvas()->setLineWidth(1);

    for ( int i = 0; i < QwtPlot::axisCnt; i++ )
    {
        QwtScaleWidget *scaleWidget = (QwtScaleWidget *)axisWidget(i);
        if ( scaleWidget )
            scaleWidget->setMargin(0);

        QwtScaleDraw *scaleDraw = (QwtScaleDraw *)axisScaleDraw(i);
        if ( scaleDraw )
            scaleDraw->enableComponent(QwtAbstractScaleDraw::Backbone, false);
    }
}


//////////////////////
//  Initialisation des lignes verticals indiquant les pics
void Plot::init_qwtplotmarker(void)
{
    // creation du QwtPlotMarker
    marqueur1 = new QwtPlotMarker();
    marqueur2 = new QwtPlotMarker();
    marqueur3 = new QwtPlotMarker();
    marqueur4 = new QwtPlotMarker();
    marqueur5 = new QwtPlotMarker();
    marqueur6 = new QwtPlotMarker();
    marqueur7 = new QwtPlotMarker();
    marqueur8 = new QwtPlotMarker();
    marqueur9 = new QwtPlotMarker();
    marqueur10 = new QwtPlotMarker();
    marqueur11 = new QwtPlotMarker();
    marqueur12 = new QwtPlotMarker();
    marqueur13 = new QwtPlotMarker();
    marqueur14 = new QwtPlotMarker();
    marqueur15 = new QwtPlotMarker();
    marqueur16 = new QwtPlotMarker();
    marqueur17 = new QwtPlotMarker();
    marqueur18 = new QwtPlotMarker();
    marqueur19 = new QwtPlotMarker();

    // on ecrit le texte
    marqueur1->setLabel(QString::fromLatin1("CH3 : 2975-2950"));
    marqueur2->setLabel(QString::fromLatin1("CH3 : 2885-2860"));
    marqueur3->setLabel(QString::fromLatin1("CH3 : 1470-1435"));
    marqueur4->setLabel(QString::fromLatin1("CH3 : 1385-1370"));
    marqueur5->setLabel(QString::fromLatin1("CH2 : 2940-2915"));
    marqueur6->setLabel(QString::fromLatin1("CH2 : 2870-2845"));
    marqueur7->setLabel(QString::fromLatin1("CH2 : 1480-1440"));
    marqueur8->setLabel(QString::fromLatin1("alcools : 3670-3580"));
    marqueur9->setLabel(QString::fromLatin1("alcools : 3550-3230"));
    marqueur10->setLabel(QString::fromLatin1("alcools : 1350-1260"));
    marqueur11->setLabel(QString::fromLatin1("alcools : 1075-1000"));
    marqueur12->setLabel(QString::fromLatin1("ctones : 1725-1700"));
    marqueur13->setLabel(QString::fromLatin1("ctones : 1360-1355"));
    marqueur14->setLabel(QString::fromLatin1("acide carboxylique : 3550-3500"));
    marqueur15->setLabel(QString::fromLatin1("acide carboxylique : 3300-2500"));
    marqueur16->setLabel(QString::fromLatin1("acide carboxylique : 1725-1700"));
    marqueur17->setLabel(QString::fromLatin1("esters : 1750-1735"));
    marqueur18->setLabel(QString::fromLatin1("esters : 1250-1170"));
    marqueur19->setLabel(QString::fromLatin1("ethers : 1150-1060"));

    // on place le texte
    marqueur1->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur2->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur3->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur4->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur5->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur6->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur7->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur8->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur9->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur10->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur11->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur12->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur13->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur14->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur15->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur16->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur17->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur18->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);
    marqueur19->setLabelAlignment(Qt::AlignRight|Qt::AlignTop);

    // trait vertical
    marqueur1->setLineStyle(QwtPlotMarker::VLine);
    marqueur2->setLineStyle(QwtPlotMarker::VLine);
    marqueur3->setLineStyle(QwtPlotMarker::VLine);
    marqueur4->setLineStyle(QwtPlotMarker::VLine);
    marqueur5->setLineStyle(QwtPlotMarker::VLine);
    marqueur6->setLineStyle(QwtPlotMarker::VLine);
    marqueur7->setLineStyle(QwtPlotMarker::VLine);
    marqueur8->setLineStyle(QwtPlotMarker::VLine);
    marqueur9->setLineStyle(QwtPlotMarker::VLine);
    marqueur10->setLineStyle(QwtPlotMarker::VLine);
    marqueur11->setLineStyle(QwtPlotMarker::VLine);
    marqueur12->setLineStyle(QwtPlotMarker::VLine);
    marqueur13->setLineStyle(QwtPlotMarker::VLine);
    marqueur14->setLineStyle(QwtPlotMarker::VLine);
    marqueur15->setLineStyle(QwtPlotMarker::VLine);
    marqueur16->setLineStyle(QwtPlotMarker::VLine);
    marqueur17->setLineStyle(QwtPlotMarker::VLine);
    marqueur18->setLineStyle(QwtPlotMarker::VLine);
    marqueur19->setLineStyle(QwtPlotMarker::VLine);

    // couleur bleu
    marqueur1->setLinePen(QPen(Qt::blue));
    marqueur2->setLinePen(QPen(Qt::blue));
    marqueur3->setLinePen(QPen(Qt::blue));
    marqueur4->setLinePen(QPen(Qt::blue));
    marqueur5->setLinePen(QPen(Qt::blue));
    marqueur6->setLinePen(QPen(Qt::blue));
    marqueur7->setLinePen(QPen(Qt::blue));
    marqueur8->setLinePen(QPen(Qt::blue));
    marqueur9->setLinePen(QPen(Qt::blue));
    marqueur10->setLinePen(QPen(Qt::blue));
    marqueur11->setLinePen(QPen(Qt::blue));
    marqueur12->setLinePen(QPen(Qt::blue));
    marqueur13->setLinePen(QPen(Qt::blue));
    marqueur14->setLinePen(QPen(Qt::blue));
    marqueur15->setLinePen(QPen(Qt::blue));
    marqueur16->setLinePen(QPen(Qt::blue));
    marqueur17->setLinePen(QPen(Qt::blue));
    marqueur18->setLinePen(QPen(Qt::blue));
    marqueur19->setLinePen(QPen(Qt::blue));


}
