#ifndef PLOT_H
#define PLOT_H

#include <qwt_plot.h>
#include <qwt_plot_marker.h>
#include <qwt_plot_curve.h>
#include <qwt_legend.h>
#include <qwt_data.h>
#include <qwt_text.h>
#include <qmainwindow.h>
#include <qwt_counter.h>
#include <qtoolbar.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qwt_plot.h>
#include <stdlib.h>
#include <qwt_painter.h>
#include <qwt_plot_curve.h>
#include <qwt_plot_canvas.h>
#include <qwt_scale_widget.h>
#include <qwt_scale_draw.h>
#include <qwt_math.h>
#include <qwt_plot_marker.h>
#include <qwt_plot_zoomer.h>
#include <qwt_scale_engine.h>
#include <qwt_legend.h>
#include <qwt_data.h>
#include <qwt_text.h>
#include <qwt_polygon.h>
#include <qregexp.h>
#include <qapplication.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qstatusbar.h>
#include <qprinter.h>
#include <qpicture.h>
#include <qpainter.h>
#include <qfiledialog.h>
#if QT_VERSION >= 0x040300
#ifdef QT_SVG_LIB
#include <qsvggenerator.h>
#endif
#endif
#if QT_VERSION >= 0x040000
#include <qprintdialog.h>
#include <qfileinfo.h>
#else
#include <qwt_painter.h>
#endif
#include <qwt_counter.h>
#include <qwt_plot_zoomer.h>
#include <qwt_plot_panner.h>
#include <qwt_text.h>
#include <qwt_math.h>
#include <qframe.h>
#include <qwt_scale_map.h>
#include <qwt_symbol.h>
#include <qcolor.h>
#include <qpaintengine.h>








class Plot : public QwtPlot
{

 public:
    Plot();

    void Init_Motors(void);
    void videPlot( void );
    void abscisse( void );
    void alignScales(void); // mise en forme de la fenetre
    void init_qwtplotmarker(void);

    // stockage des valeurs de la position des membres
    double *val1;
    double *val2;
    double *val3;
    double *val4;
    double *val5;
    double *val6;
    double *val7;
    double *val8;
    double *val9;
    double *val10;
    double *val11;
    double *val12;
    double *val13;
    double *val14;

    // creation des courbes
    QwtPlotCurve *courbe1; // 0
    QwtPlotCurve *courbe2; // 10
    QwtPlotCurve *courbe3; // inconnu
    QwtPlotCurve *courbe4; // 20
    QwtPlotCurve *courbe5; // A
    QwtPlotCurve *courbe6; // B
    QwtPlotCurve *courbe7; // C
    QwtPlotCurve *courbe8; // D
    QwtPlotCurve *courbe9; // BACKGROUND
    QwtPlotCurve *courbe10; // CUVE VIDE
    QwtPlotCurve *courbe11; // A - CCL4
    QwtPlotCurve *courbe12; // B - CCL4
    QwtPlotCurve *courbe13; // C - CCL4
    QwtPlotCurve *courbe14; // D - CCL4

    // traits verticaux pour donner la position des raies A, B, C et D
    QwtPlotMarker *marqueur1; // CH3 2975-2950
    QwtPlotMarker *marqueur2; // CH3 2885-2860    
    QwtPlotMarker *marqueur3; // CH3 1470-1435
    QwtPlotMarker *marqueur4; // CH3 1385-1370
    QwtPlotMarker *marqueur5; // CH2 2940-2915
    QwtPlotMarker *marqueur6; // CH2 2870-2845
    QwtPlotMarker *marqueur7; // CH2 1480-1440
    QwtPlotMarker *marqueur8; // OH 3670-3580
    QwtPlotMarker *marqueur9; // OH 2940-2915
    QwtPlotMarker *marqueur10; // OH 1350-1260
    QwtPlotMarker *marqueur11; // OH 1075-1000
    QwtPlotMarker *marqueur12; // CH3 1725-1700
    QwtPlotMarker *marqueur13; // CH3 1360-1355
    QwtPlotMarker *marqueur14; // acide carboxylique 3550-3500
    QwtPlotMarker *marqueur15; // acide carboxylique 3300-2500
    QwtPlotMarker *marqueur16; // acide carboxylique 1725-1700
    QwtPlotMarker *marqueur17; // esters 1750-1735
    QwtPlotMarker *marqueur18; // esters 1250-1170
    QwtPlotMarker *marqueur19; // ethers 1150-1060



    // nombre de points a afficher
    int pointsAAfficher;

    // stockage des valeurs de la variable
    double *stockVariable; 

    // stockage de l'axe des abscisses
    double *xPoints;

    double valmin; // valeur minimum prise par la variable
    double valmax; // valeur maximum prise par la variable

};


class Zoomer: public QwtPlotZoomer
{
public:
    Zoomer(int xAxis, int yAxis, QwtPlotCanvas *canvas): QwtPlotZoomer(xAxis, yAxis, canvas, TRUE)
    {

        setSelectionFlags(QwtPicker::DragSelection | QwtPicker::CornerToCorner);
        setTrackerMode(QwtPicker::AlwaysOff);
        setRubberBand(QwtPicker::NoRubberBand);

        // RightButton: zoom out by 1
        // Ctrl+RightButton: zoom out to full size
        setMousePattern(QwtEventPattern::MouseSelect2, Qt::RightButton, Qt::ControlModifier);
        setMousePattern(QwtEventPattern::MouseSelect3, Qt::RightButton);

    }
};



#endif

