
#include <QtGui>

#include "quadstar.h"

#include "quadstar_page1.cpp"
#include "quadstar_page2.cpp"
#include "quadstar_page3.cpp"
#include "quadstar_page4.cpp"

QuadStar::QuadStar(QWidget *parent) : QMainWindow(parent)
{

  ui.setupUi(this);

  port = NULL;

  // decoration des boutons
  ui.pushButton_15->setIcon(QPixmap(":/print3.png")); 


  // creation du thread qui met a jour les valeurs
  void *ptclass = (void*) this;
  SDL_t1 = SDL_CreateThread(threadSDL, ptclass);

  visionGraph.Init_Motors();

  state1=0;
  state2=0;
  state3=0;
  state4=0;
  state5=0;
  state6=0;
  state7=0;
  state8=0;
  state9=0;
  state10=0;
  state11=0;
  state12=0;
  state13=0;
  state14=0;
  statezoom = 0;
  state_pics = 0;


  message_a_afficher = "";

  recup=0;

  // curseur avec position (page 3)
  d_panner = NULL;
  d_picker = NULL;

  // conversion des fichiers JDM en TXT
  conversion();


  // creation du tableur
  int lignes = 1976;
  int colonnes = 14;
  model = new QStandardItemModel(lignes, colonnes); // 1976 lignes et 10 colonnes
  model->setHeaderData(0, Qt::Horizontal, tr("Background"));
  model->setHeaderData(1, Qt::Horizontal, tr("Cuve vide"));
  model->setHeaderData(2, Qt::Horizontal, tr("0%"));
  model->setHeaderData(3, Qt::Horizontal, tr("10%"));
  model->setHeaderData(4, Qt::Horizontal, tr("? %"));
  model->setHeaderData(5, Qt::Horizontal, tr("20%"));    
  model->setHeaderData(6, Qt::Horizontal, tr("A"));
  model->setHeaderData(7, Qt::Horizontal, tr("B"));
  model->setHeaderData(8, Qt::Horizontal, tr("C"));
  model->setHeaderData(9, Qt::Horizontal, tr("D"));
  model->setHeaderData(10, Qt::Horizontal, tr("A - CCL4"));
  model->setHeaderData(11, Qt::Horizontal, tr("B - CCL4"));
  model->setHeaderData(12, Qt::Horizontal, tr("C - CCL4"));
  model->setHeaderData(13, Qt::Horizontal, tr("D - CCL4"));
  for (int row = 0; row < lignes; ++row) 
  {
    model->setHeaderData(row, Qt::Vertical, QString::number(4400 - 2 * row) );
  }  
  ui.tableView->setModel(model);
  ui.tableView->setItemDelegate(&delegate);
  for (int row = 0; row < lignes; ++row) 
  {
    for (int column = 0; column < colonnes; ++column) 
    {
      index = model->index(row, column, QModelIndex());
      model->setData(index, QVariant(0));
    }
  }  

  // on initialise le zoom
  d_zoomer[0] = NULL;
  d_zoomer[1] = NULL;


  // chargement des graphes
  chargement_valeurs();

  // definition de la fenetre graphique
  visionGraph.resize(600,600);

}

QuadStar::~QuadStar()
{
  if (visionGraph.isHidden() == 0)
         visionGraph.hide();
}
