// La page 1 concerne tout ce qui touche a la reception des donnees


////////////////////////////////////////
// connexion et ouverture du port
void QuadStar::on_pushButton_2_clicked()
{
  message_a_afficher = "";

  // on efface l'ecran terminal
  ui.textBrowser_2->clear(); // on efface le terminal 

  //modify the port settings on your own
  if(port == NULL)
  {
       port = new QextSerialPort("COM1"); 
       port->setBaudRate(BAUD9600);    // 9600 bauds
       port->setFlowControl(FLOW_HARDWARE); //  controle materiel
       port->setParity(PAR_NONE);    // pas de parite
       port->setDataBits(DATA_8);   // 8 bits de donnees
       port->setStopBits(STOP_1);    // bit de stop 1.0
  }
  else
  {
	   port->close();
       delete port;
       port = NULL;
       recup = 0;

       port = new QextSerialPort("COM1"); 
       port->setBaudRate(BAUD9600);    // 96000 bauds
       port->setFlowControl(FLOW_HARDWARE); // controle materiel
       port->setParity(PAR_NONE);    // pas de parite
       port->setDataBits(DATA_8);   // 8 bits de donnees
       port->setStopBits(STOP_1);    // bit de stop 1.0
  }

  // ouverture du port
  port->open(QIODevice::ReadWrite);
  if(port->isOpen() != 1)
  {
    send_commande2R("Erreur de connexion sur le COM1");
	port->close();
    delete port;
    port = NULL;
    recup = 0;
    message_a_afficher = "";
  }
  else
  {
    send_commande2G("En attente de la transmission des donnees");
    recup=1;
  }

}

////////////////////////////////////////
// sauvegarde du spectre dans un fichier
void QuadStar::on_pushButton_3_clicked()
{
  int value = ui.comboBox->currentIndex(); 
  if(value == 0)
    return; // il n'y a pas de nom de fichier

  QString name_file = ui.comboBox->currentText();

  QString texte = message_a_afficher;

  // si le texte est vide, on quitte
  if(texte == "")
    return;

  // on retire des caracteres
  texte.replace(QString("\x0D"), QString(""));


  // on met un avertissement si le spectre existe deja
  QFile file_test;
  QString name_file_test = "data/" + name_file;
  name_file_test.replace( QString("JDX"), QString("TXT") );
  file_test.setFileName( name_file_test ); 
  if( file_test.exists() )
  {
    QMessageBox msgBox(QMessageBox::Warning, "Attention", "Il existe dj un spectre portant le nom de " + name_file + ". \n Etes-vous sr de vouloir enregistrer par dessus ce spectre ?", 0, this);
    msgBox.addButton("Oui, continuer", QMessageBox::AcceptRole);
    msgBox.addButton("Annuler l'enregistrement", QMessageBox::RejectRole);
    if (msgBox.exec() == QMessageBox::AcceptRole)
    {}
    else
    {
      send_commande2R("");
      send_commande2R("Enregistrement annul");
      return;
    }
  }

  name_file_JDX = name_file;


  QFile file;
  file.setFileName("data/" + name_file); 
  if( file.exists() )
    file.remove();
  file.open(QIODevice::Append | QIODevice::Text );
  QTextStream out(&file);
  out << texte << endl;    
  file.close();

  // conversion des fichiers JDM en TXT
  conversion();
  // chargement des graphes
  chargement_valeurs();

  // on prvient l'utilisateur que c'est enregistre
  send_commande2R("");
  send_commande2R("Donnees sauvegardees");

}


int threadSDL(void *ptclass)
{

  // on recupere l'adresse de notre classe
  QuadStar *pt = static_cast<QuadStar *>(ptclass);

  while(1)
  {
    // on ne fait rien tant que l'on n'est pas connecte
    if( (pt->port == NULL) || pt->recup == 0)
    {
      Sleep(500);
    }
    
    else
    {
      pt->e1 = new QEvent((QEvent::Type)(1001));
      QCoreApplication::postEvent(pt,pt->e1);
      Sleep(2500);
    }
  }

  return 1;
}



///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool QuadStar::event(QEvent *ev)
{
     
 if( ev->type() == (QEvent::Type)(1001))
 {
    reception();
 }

 return 1;
}


////////////////////////////////////////
// lire !
void QuadStar::reception()
{
  QString msg;
  char buff[4096];
  int numBytes;
  
  numBytes = port->bytesAvailable();
  if(numBytes == 0) 
  {
//    send_commande2R("Aucune donnee recue");
  }
  else
  {
//    send_commande2G("Donnees a recuperer : " + QString::number(numBytes)  );
    if(numBytes > 4096) numBytes = 4096;
	int i = port->read(buff, numBytes);
	buff[i] = '\0';
	msg = buff;
    message_a_afficher =  message_a_afficher + msg;

    if(msg.contains("##END=") )   
    {
       recup = 0;         
       send_commande3(message_a_afficher);
    }

  }

}

////////////////////////////////////////
// affichage de ce qui est fait
int QuadStar::send_commande2R(QString la_commande)
{
  int valeur_retour = 0; // par defaut, on met a 0

  // affichage de ce qui est envoye
  QTextCursor cursorEnd(ui.textBrowser_2->textCursor());
  cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
  ui.textBrowser_2->setTextCursor ( cursorEnd );
  ui.textBrowser_2->setTextColor(QColor::QColor ( 255, 0, 0 )); // on decide la couleur par defaut 
  ui.textBrowser_2->insertPlainText( la_commande.toLatin1() + "\n" ); 
  int positionMax = ui.textBrowser_2->verticalScrollBar()->maximum();
  ui.textBrowser_2->verticalScrollBar()->setSliderPosition(positionMax);

  return valeur_retour; // 0 = tout va bien et -1 = probleme
}

////////////////////////////////////////
// affichage de ce qui est fait
int QuadStar::send_commande2G(QString la_commande)
{
  int valeur_retour = 0; // par defaut, on met a 0

  // affichage de ce qui est envoye
  QTextCursor cursorEnd(ui.textBrowser_2->textCursor());
  cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
  ui.textBrowser_2->setTextCursor ( cursorEnd );
  ui.textBrowser_2->setTextColor(QColor::QColor ( 0, 255, 0 )); // on decide la couleur par defaut 
  ui.textBrowser_2->insertPlainText( la_commande.toLatin1() + "\n" ); 
  int positionMax = ui.textBrowser_2->verticalScrollBar()->maximum();
  ui.textBrowser_2->verticalScrollBar()->setSliderPosition(positionMax);

  return valeur_retour; // 0 = tout va bien et -1 = probleme
}

////////////////////////////////////////
// affichage de ce qui est fait
int QuadStar::send_commande2B(QString la_commande)
{
  int valeur_retour = 0; // par defaut, on met a 0

  // affichage de ce qui est envoye
  QTextCursor cursorEnd(ui.textBrowser_2->textCursor());
  cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
  ui.textBrowser_2->setTextCursor ( cursorEnd );
  ui.textBrowser_2->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
  ui.textBrowser_2->insertPlainText( la_commande.toLatin1() + "\n" ); 
  int positionMax = ui.textBrowser_2->verticalScrollBar()->maximum();
  ui.textBrowser_2->verticalScrollBar()->setSliderPosition(positionMax);

  return valeur_retour; // 0 = tout va bien et -1 = probleme
}


////////////////////////////////////////
// affichage de ce qui est recu
int QuadStar::send_commande3(QString la_commande)
{

  // affichage de ce qui est recu
  QTextCursor cursorEnd(ui.textBrowser_2->textCursor());
  cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
  ui.textBrowser_2->setTextCursor ( cursorEnd );
  ui.textBrowser_2->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
  ui.textBrowser_2->insertPlainText( la_commande.toLatin1() + "\n" ); 
  int positionMax = ui.textBrowser_2->verticalScrollBar()->maximum();
  ui.textBrowser_2->verticalScrollBar()->setSliderPosition(positionMax);

  return 0; 
}
