#ifndef CAPTUREIMAGE_H
#define CAPTUREIMAGE_H

#include "ui_captureimage.h"
#include "myqgraphicsscene.h"
#include "delegate.h"
//#include "matrice.h"
#include <QWidget>
#include <QtGui>

#include <math.h>

#include "plot.h" // pour l'affichage du graphique

// les matrices avec boost
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/vector_proxy.hpp>
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/triangular.hpp>
#include <boost/numeric/ublas/lu.hpp>
//#include "boost_1_35_0/boost/numeric/ublas/io.hpp"
namespace ublas = boost::numeric::ublas;


class CaptureImage : public QMainWindow
{
    Q_OBJECT

public:
  CaptureImage(QWidget *parent = 0);
  Ui::CaptureImage ui;

  // page 2
  void equation_courbe(void); // trouver l'equation de la courbe
  long double regPolynomiale(int degre,long double *coeffs,long double *coeffs_incertitude,long double *vals[2],int deb,int fin);

  // page 3 ==> graphique
  void page3_init(); // creation tableur
  int affichage(QString la_commande); // affichage a l'ecran
  void sauver_resultats(void); // Sauvegarde des resultats
  QStandardItemModel *modelRef;
  QStandardItemModel *modelIdent;
  SpinBoxDelegate delegateRef;
  SpinBoxDelegate delegateIdent;
  QModelIndex indexRef;
  QModelIndex indexIdent;
  long double *coeffs3;
  long double *coeffs_incertitude3;
  long double ecarttype3;


  // plot
  Plot visionGraph; // fenetre pour afficher les graphs des moteurs
  void enableZoomMode(bool);
  void chargement_valeurs(void); // chargement des valeurs
  Zoomer *d_zoomer[2];
  QwtPlotPicker *d_picker ;
  QwtPlotPanner *d_panner ;

  // page matrice ==> matrices
  void transp_mat(double **ma, double **mb, int max);
  void det_aux(double **ma,double **mb,int l,int c, int max);
  double expo(int n);
  double determinant(double **m,int l, int max);
  void multi_R(double a, double **ma,double **mb,int max);
  void coffacteur(double **ma,double **mb,int ligne,int max);
  void inverse(double **ma,double **mb,int ligne,int max);
  double ** create_matrice_carre(double **matrice,int max);
  double ** create_matrice(double **matrice,int colonne,int ligne);

public slots:
  //page 3
    void on_pushButton_clicked(); // imprimer le graph
    void on_pushButton_7_clicked(); // affichage du graph
    void on_pushButton_8_clicked(); // calcul de tous les coefficients

};

#endif
