/*
 j espere que vous vous rappelez de la formule...
 calcul de l'inverse de M via la formule thorique
*/


// on copie ma dans mb en faisant une transposition (inversion des lignes et colonnes)
// m2 est integralement creer a partir de m1
void CaptureImage::transp_mat(double **ma, double **mb, int max)
{
  int i,j;
  for (i=0;i<max;i++)
  {
    for (j=0;j<max;j++)
    {
      mb[j][i]=ma[i][j];
    }
  }



}


// m2 est la copie de m1, sauf pour une colonne et une ligne
void CaptureImage::det_aux(double **ma,double **mb,int ligne, int colonne, int max)      //calcul du mineur 
{

  // La determinante de la matrice kon a si on supprimme la ligne et
  // la colonne de l'element dont on doit calculer le mineur.

  int i,j;
  int d=0;
  int e=0;

  for(i=0;i<max;i++)
  {
    d=0;
    if(i!=ligne)
    {
      for(j=0;j<max;j++)
      {
        if(j!=colonne)
        {
          mb[e][d]=ma[i][j];
          d++;
        }
      }
      e++;
    }
  }
}



double CaptureImage::expo(int n)         //fonction signe
{
  if(!(n%2))
  {
    return (1);
  }
  return (-1);
}



double CaptureImage::determinant(double **m1,int ligne, int max)
{
  // creation de la matrice m2
  const int dimension = max; 
  double **m2 = NULL ;
  m2 = new double * [dimension];
  for (int i=0; i<dimension; ++i )
    m2 [i] = new double [dimension];


  int i;
  double x=0;
  if(ligne==1)
  {
    return m1[0][0];
  }
  for(i=0;i<ligne;i++)
  {
    det_aux(m1,m2,i,0,max); 
    x = x + ( expo(i) * m1[i][0] * determinant(m2,(ligne-1),max) ); 
  }


  // suppression de la matrice m2
  if (m2) 
  {
    for (int i=0; i<dimension; ++i )
      delete m2[i];
    delete m2;
  }

  return x;
}



// matrice b = matrice a * valeur
void CaptureImage::multi_R(double a, double **ma,double **mb,int max)
{
  int i,j;
  for(i=0;i<max;i++)
  {
    for(j=0;j<max;j++)
    {
      mb[i][j]=ma[i][j]*a;
    }
  }
}


void CaptureImage::coffacteur(double **ma,double **mb,int ligne,int max)
{
  // creation de la matrice m2
  const int dimension = max; 
  double **m2 = NULL ;
  m2 = new double * [dimension];
  for (int i=0; i<dimension; ++i )
    m2 [i] = new double [dimension];


  int i,j;
  if (ligne==1)
  {
    mb[0][0]=1;
  }
  else
  {
    for (i=0;i<ligne;i++)
    {
      for (j=0;j<ligne;j++)
      {
        det_aux(ma,m2,i,j,max); // m2 est la copie de ma, sauf pour une colonne et une ligne
        mb[i][j]= expo(i+j) * determinant(m2,(ligne - 1),max) ;
      }
    }
  }


  // suppression de la matrice m2
  if (m2) 
  {
    for (int i=0; i<dimension; ++i )
      delete m2[i];
    delete m2;
  }

}



/////////////////////////////////////////////
// Inversion de matrice
void CaptureImage::inverse(double **ma,double **mb,int ligne,int max)
{

  // creation des matrices m1 et m2
  const int dimension = max; 
  double **m2 = NULL ;
  double **m1 = NULL ;
  m1 = new double * [dimension];
  m2 = new double * [dimension];
  for (int i=0; i<dimension; ++i )
  {
    m1 [i] = new double [dimension];
    m2 [i] = new double [dimension];
  }


  double d;


  d=( 1 / determinant(ma,ligne,max) );
  coffacteur(ma,m1,ligne,max);
  transp_mat(m1,m2,max); // m2 est integralement creer a partir de m1
  multi_R(d,m2,mb,max);


  // suppression des matrices
  if (m2 && m1) 
  {
    for (int i=0; i<dimension; ++i )
    {
      delete m1[i];
      delete m2[i];
    }
    delete m1;
    delete m2;
  }

}

/////////////////////////////////////////////
// Creation de matrice carre
double ** CaptureImage::create_matrice_carre(double **matrice,int max)
{
  // creation du nombre de colonnes, puis du nombre de lignes
  // format [colonne][ligne]

  const int dimension = max; 
  matrice = new double * [dimension];
  for (int i=0; i<dimension; ++i )
  {
    matrice [i] = new double [dimension];
  }

  return matrice;

}

/////////////////////////////////////////////
// Creation de matrice non carre
double ** CaptureImage::create_matrice(double **matrice,int colonne,int ligne)
{

  // creation du nombre de colonnes, puis du nombre de lignes
  // format [colonne][ligne]

  const int dimension1 = colonne; 
  const int dimension2 = ligne; 
  matrice = new double * [dimension1];
  for (int i=0; i<dimension1; ++i )
  {
    matrice [i] = new double [dimension2];
  }

  return matrice;

}
