////////////////////////////////////////
// Initialisation
void CaptureImage::page3_init()
{
  modelRef=NULL;
  modelIdent=NULL;

  visionGraph.Init_Motors();
  d_panner = NULL;
  d_picker = NULL;

  coeffs3 = NULL;
  coeffs_incertitude3 = NULL;

  // decoration des boutons
  ui.pushButton_7->setIcon(QPixmap(":/buttonReg4.png"));
  ui.pushButton->setIcon(QPixmap(":/print3.png")); 

  // on calcule les coefficients
  on_pushButton_8_clicked();
  
  // on affiche le graph
  on_pushButton_7_clicked();


}

////////////////////////////////////////
// calcul de tous les coefficients
void CaptureImage::on_pushButton_8_clicked()
{
     
  // on commence par effacer le terminal
  ui.textBrowser->clear(); // on efface le terminal 


////////////////////////////////////////////////////////////////////////////////
// Remplissage du tableau rfrence
////////////////////////////////////////////////////////////////////////////////

  affichage("On rcupre les valeurs en absorbance en 3018 cm-1");

  // 0% ==> CCL4
  QFile file;

  file.setFileName("0.TXT");
  if( !file.exists() )
  {
    affichage("Erreur, la solution 0% n'a pas t trouve");
    return;
  }
  double value0;
  file.open(QIODevice::ReadOnly | QIODevice::Text );
  QTextStream in(&file);
  QString line;
  while (!in.atEnd() && !line.contains("3018") ) 
  {
    line = in.readLine(); 
  }
  // fermeture des fichiers
  file.close();
  line.remove(0, line.indexOf(";")+1 );
  value0 = line.toDouble();
  affichage("Abs de 0% ==> " + QString::number(value0) );

  file.setFileName("10.TXT");
  if( !file.exists() )
  {
    affichage("Erreur, la solution 10% n'a pas t trouve");
    return;
  }
  double value10;
  file.open(QIODevice::ReadOnly | QIODevice::Text );
  QTextStream in2(&file);
  while (!in2.atEnd() && !line.contains("3018") ) 
  {
    line = in2.readLine(); 
  }
  // fermeture des fichiers
  file.close();
  line.remove(0, line.indexOf(";")+1 );
  value10 = line.toDouble();
  affichage("Abs de 10% ==> " + QString::number(value10) );

  file.setFileName("20.TXT");
  if( !file.exists() )
  {
    affichage("Erreur, la solution 20% n'a pas t trouve");
    return;
  }
  double value20;
  file.open(QIODevice::ReadOnly | QIODevice::Text );
  QTextStream in3(&file);
  while (!in3.atEnd() && !line.contains("3018") ) 
  {
    line = in3.readLine(); 
  }
  // fermeture des fichiers
  file.close();
  line.remove(0, line.indexOf(";")+1 );
  value20 = line.toDouble();
  affichage("Abs de 20% ==> " + QString::number(value20) );

  file.setFileName("inconnu.TXT");
  if( !file.exists() )
  {
    affichage("Erreur, la solution inconnue n'a pas t trouve");
    return;
  }
  double value12;
  file.open(QIODevice::ReadOnly | QIODevice::Text );
  QTextStream in4(&file);
  while (!in4.atEnd() && !line.contains("3018") ) 
  {
    line = in4.readLine(); 
  }
  // fermeture des fichiers
  file.close();
  line.remove(0, line.indexOf(";")+1 );
  value12 = line.toDouble();
  affichage("Abs de inconnue ==> " + QString::number(value12) );


  affichage("" );

  affichage("" );



////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////
// calcul des coefficients
////////////////////////////////////////////////////////////////////////////////

  int debut = 0;
  int fin = 2; // points

  // creation du stockage des valeurs
  long double **vals = NULL;
  vals = new long double * [2]; // creation des 2 colonnes
  for (int i=0; i<2; ++i ) // 2 colonnes
  {
    vals [i] = new long double [3]; // lignes
  }

 // on remplit les valeurs
 vals[0][0] = 0;
 vals[1][0] = value0;
 vals[0][1] = 10;
 vals[1][1] = value10;
 vals[0][2] = 20;
 vals[1][2] = value20;


  // on cherche l'equation d'une courbe polynomiale de degre 1
  int degre = 1;
  if(coeffs3 != NULL)
  {
    free(coeffs3);
    free(coeffs_incertitude3);
  }
  coeffs3 = new long double [degre+1];
  coeffs_incertitude3 = new long double [degre+1];
  ecarttype3 = regPolynomiale(degre,coeffs3,coeffs_incertitude3,vals,debut,fin);

////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////
// affichage des resultats
////////////////////////////////////////////////////////////////////////////////



  affichage("Regression lineaire : y = a.x + b");
  affichage("a = " + QString::number((double)coeffs3[1]) );
  affichage("b = " + QString::number((double)coeffs3[0]) );


  affichage("" );

  affichage("" );

  affichage("Calcul de la concentration de la solution inconnue en % de volume" );
  double inconnue_concentration = ( value12 - coeffs3[0] ) / coeffs3[1] ;
  affichage("Concentration inconnue = " + QString::number(inconnue_concentration) );

  affichage("" );
  affichage("-------------------------------------" );
  affichage("" );

  affichage("On rcupre les valeurs en absorbance en 3018 cm-1");
  affichage("Abs de 0 mol/L ==> " + QString::number(value0) );
  affichage("Abs de 1,25 mol/L ==> " + QString::number(value10) );
  affichage("Abs de 2,5 mol/L ==> " + QString::number(value20) );
  affichage("Abs de inconnue ==> " + QString::number(value12) );


  affichage("" );

  debut = 0;
  fin = 2; // points

  // creation du stockage des valeurs
  vals = new long double * [2]; // creation des 2 colonnes
  for (int i=0; i<2; ++i ) // 2 colonnes
  {
    vals [i] = new long double [3]; // lignes
  }

 // on remplit les valeurs
 vals[0][0] = 0;
 vals[1][0] = value0;
 vals[0][1] = 1.25;
 vals[1][1] = value10;
 vals[0][2] = 2.5;
 vals[1][2] = value20;


  // on cherche l'equation d'une courbe polynomiale de degre 1
  degre = 1;
  if(coeffs3 != NULL)
  {
    free(coeffs3);
    free(coeffs_incertitude3);
  }
  coeffs3 = new long double [degre+1];
  coeffs_incertitude3 = new long double [degre+1];
  ecarttype3 = regPolynomiale(degre,coeffs3,coeffs_incertitude3,vals,debut,fin);

  affichage("Regression lineaire : y = a.x + b");
  affichage("a = " + QString::number((double)coeffs3[1]) );
  affichage("b = " + QString::number((double)coeffs3[0]) );


  affichage("" );

  affichage("" );

  affichage("Calcul de la concentration de la solution inconnue en mol/L" );
  inconnue_concentration = ( value12 - coeffs3[0] ) / coeffs3[1] ;
  affichage("Concentration inconnue = " + QString::number(inconnue_concentration) );


////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Remplissage du graphique
////////////////////////////////////////////////////////////////////////////////

// on redimensionne la fenetre
  visionGraph.setAxisScale(QwtPlot::xBottom, 0, 2.5);
  visionGraph.setAxisScale(QwtPlot::yLeft, 0, 1);
  visionGraph.valmaxY = value20;
  visionGraph.valminY = value0;
  visionGraph.valmaxX = 2.5;
  visionGraph.valminX = 0;



  // on cherche le nombre de points a afficher
  visionGraph.pointsAAfficherRef = 3; // 3 points
  visionGraph.pointsAAfficherIdent = 2; // 2 points pour faire la droite
  visionGraph.pointsAAfficherIdent2 = 1; // 1 point
  visionGraph.setAxisScale(QwtPlot::xBottom, visionGraph.valminX, visionGraph.valmaxX);

  visionGraph.videPlot( ); // on libere la memoire

  visionGraph.abscisse( ); // on remplit l'axe des abscisses

  // on remplit le tableau Ref
  visionGraph.xPointsRef[0] = 0;
  visionGraph.xPointsRef[1] = 1.25;
  visionGraph.xPointsRef[2] = 2.5;
  visionGraph.val1[0] = value0;
  visionGraph.val1[1] = value10;
  visionGraph.val1[2] = value20;

  // on remplit le tableau Ident2
  visionGraph.xPointsIdent2[0] = inconnue_concentration;
  visionGraph.val8[0] = value12;

  // on remplit le tableau Ident
  visionGraph.xPointsIdent[0] = 0;
  visionGraph.xPointsIdent[1] = 2.5;
  visionGraph.val4[0] = coeffs3[0];
  visionGraph.val4[1] = visionGraph.xPointsIdent[1]*coeffs3[1]+coeffs3[0];

  // on regarde les dimensions du graph
  if(visionGraph.val4[0] < visionGraph.val1[0])
    visionGraph.valminY = visionGraph.val4[0];

  // on regarde les dimensions du graph
  if(visionGraph.val4[1] > visionGraph.val1[2])
    visionGraph.valmaxY = visionGraph.val4[1];

  visionGraph.setAxisScale(QwtPlot::yLeft, visionGraph.valminY, visionGraph.valmaxY);


// affichage de la position du curseur
  if( d_panner == NULL)
  {
    d_panner = new QwtPlotPanner(visionGraph.canvas());
    d_panner->setMouseButton(Qt::MidButton);
    d_picker = new QwtPlotPicker(QwtPlot::xBottom, QwtPlot::yLeft,  QwtPicker::PointSelection | QwtPicker::DragSelection, QwtPlotPicker::CrossRubberBand, QwtPicker::AlwaysOn, visionGraph.canvas());
    d_picker->setRubberBandPen(QColor(Qt::green));
    d_picker->setRubberBand(QwtPicker::CrossRubberBand);
    d_picker->setTrackerPen(QColor(Qt::black));
  }

  // update the display
  visionGraph.replot();

////////////////////////////////////////////////////////////////////////////////





////////////////////////////////////////////////////////////////////////////////
// Liberation memoire
////////////////////////////////////////////////////////////////////////////////

  free(vals[0]);
  free(vals[1]);
  free(vals);
////////////////////////////////////////////////////////////////////////////////



}





////////////////////////////////////////
// affichage de ce qui est fait
int CaptureImage::affichage(QString la_commande)
{
  int valeur_retour = 0; // par defaut, on met a 0

  // affichage de ce qui est envoye
  QTextCursor cursorEnd(ui.textBrowser->textCursor());
  cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
  ui.textBrowser->setTextCursor ( cursorEnd );
  ui.textBrowser->setTextColor(QColor::QColor ( 255, 0, 0 )); // on decide la couleur par defaut 
  ui.textBrowser->insertPlainText( la_commande.toLatin1() + "\n" ); 
  int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
  ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);

  return valeur_retour; // 0 = tout va bien et -1 = probleme
}


////////////////////////////////////////
// Affichage du graph
void CaptureImage::on_pushButton_7_clicked()
{

  if (visionGraph.isHidden() == 1)
  {
         visionGraph.resize(600,600);
         visionGraph.setTitle( "Absorption en fonction de la concentration" );   
         visionGraph.show();
  }
  else
  {
         visionGraph.hide();
  }

  // update the display
  visionGraph.replot();

  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val4 == NULL)
    return;

  // afichage du spectre de degre 3
    visionGraph.courbe4->setVisible(true);

  // update the display
  visionGraph.replot();


}





////////////////////////////////////////
// on imprime
void CaptureImage::on_pushButton_clicked()
{
     
  // creation d'une imprimante
  QPrinter printer;

  // on demande a choisir l'imprimante
  QPrintDialog *dlg = new QPrintDialog(&printer, this);
  if (dlg->exec() != QDialog::Accepted)
    return;

  QwtPlotPrintFilter filter;
  int options = QwtPlotPrintFilter::PrintAll;
  options &= ~QwtPlotPrintFilter::PrintBackground;
  options |= QwtPlotPrintFilter::PrintFrameWithScales;
  filter.setOptions(options);
  visionGraph.print(printer,filter);

}
