#include "plot.h"

Plot::Plot()
{
        valminY=0;
        valmaxY=1;
        valminX=0;
        valmaxX=20;
}


///////////////////////////////////////
// Initialisation des valeurs dans le cas de moteurs
void Plot::Init_Motors()
{

    // Disable polygon clipping
    QwtPainter::setDeviceClipping(false);

    // We don't need the cache here
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintCached, false);
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintPacked, false);

#ifdef Q_WS_X11
    canvas()->setAttribute(Qt::WA_PaintOnScreen, true);
#endif

    // Assign a title
//    setTitle("Graphique");
    insertLegend(new QwtLegend(), QwtPlot::BottomLegend);

    alignScales();

    // tableau contenant les valeurs
    val1 = NULL;
    val4 = NULL;
    val8 = NULL;
    xPointsRef = NULL;
    xPointsIdent = NULL;
    xPointsIdent2 = NULL;

    // Axis titles
    setAxisTitle(QwtPlot::xBottom, "Concentration de la solution en % de volume"); // titre de l'axe des X
    setAxisScale(QwtPlot::xBottom, valminX, valmaxX);
//    setAxisScaleEngine(QwtPlot::xBottom, new QwtLog10ScaleEngine);

    setAxisTitle(QwtPlot::yLeft, "Abs"); // permet de mettre un titre a l'axe des Y
    setAxisScale(QwtPlot::yLeft, valminY, valmaxY);

}


void Plot::videPlot()
{


    // On libere la memoire des tableaux
    if (val1 != NULL)
    {

            delete val1; 
            delete val4; 
            delete val8; 

            delete xPointsRef;
            delete xPointsIdent;
            delete xPointsIdent2;

            delete courbe1; 
            delete courbe4;
            delete courbe8;

            val1 = NULL; 
            val4 = NULL; 
            val8 = NULL; 
            xPointsRef = NULL;
            xPointsIdent = NULL;
            xPointsIdent2 = NULL;

            courbe1 = NULL; 
            courbe4 = NULL; 
            courbe8 = NULL; 

      }



}


//////////////////////////////////////////////////
// remplir l'echelle des abscisses
void Plot::abscisse(void)
{

    if (val1 == NULL)
    {
            // Creation des tableaux qui vont stocker les valeurs
            val1 = new double[pointsAAfficherRef];
            val4 = new double[pointsAAfficherIdent];
            val8 = new double[pointsAAfficherIdent2];

            xPointsRef = new double[pointsAAfficherRef];
            xPointsIdent = new double[pointsAAfficherIdent];
            xPointsIdent2 = new double[pointsAAfficherIdent2];

        // on vide les tableaux
         for( int i=0; i<pointsAAfficherRef; i++ )
         {
            xPointsRef[i] = 0;
            val1[i] = 0;
         }
         for( int i=0; i<pointsAAfficherIdent2; i++ )
         {
            xPointsIdent2[i] = 0;
            val8[i] = 0;
         }
         for( int i=0; i<pointsAAfficherIdent; i++ )
         {
            xPointsIdent[i] = valminX + i;
            val4[i] = 0;
         }

        // Insert new curves
        courbe1 = new QwtPlotCurve("Points des solutions de Rfrence");
        courbe4 = new QwtPlotCurve("Droite de rgression linaire");
        courbe8 = new QwtPlotCurve("Point de la solution Inconnue");


        QwtSymbol sym;
        QwtSymbol sym2;
        sym.setStyle(QwtSymbol::XCross);
        sym.setPen(QColor(Qt::red));
//        sym2.setStyle(QwtSymbol::XCross);
        sym2.setStyle(QwtSymbol::Ellipse);
        sym2.setPen(QColor(Qt::blue));
        sym.setSize(10);
        sym2.setSize(10);
        courbe1->setSymbol(sym);
        courbe1->setStyle(QwtPlotCurve::NoCurve);
        courbe8->setSymbol(sym2);
        courbe8->setStyle(QwtPlotCurve::NoCurve);
//        courbe8->setStyle(QwtPlotCurve::Sticks);

        courbe1->attach(this);
        courbe4->attach(this);
        courbe8->attach(this);


        // Set curve styles
        courbe1->setPen(QPen(Qt::red));
        courbe4->setPen(QPen(Qt::black));
        courbe8->setPen(QPen(Qt::blue));


        // on demande a ce que la courbe ne s'affiche pas
        courbe1->setVisible(true);
        courbe4->setVisible(true);
        courbe8->setVisible(true);

        // Attach (don't copy) data. Both curves use the same x array.
        courbe1->setRawData(xPointsRef, val1, pointsAAfficherRef);
        courbe4->setRawData(xPointsIdent, val4, pointsAAfficherIdent);
        courbe8->setRawData(xPointsIdent2, val8, pointsAAfficherIdent2);


        // on met le cadre aux bonnes dimensions 
        setAxisScale(QwtPlot::yLeft, 0, 1);

    }

}


//////////////////////
//  Mise en forme de la fenetre avec bon repositionnement des elements
void Plot::alignScales()
{

    // The code below shows how to align the scales to
    // the canvas frame, but is also a good example demonstrating
    // why the spreaded API needs polishing.

    canvas()->setFrameStyle(QFrame::Box | QFrame::Plain );
    canvas()->setLineWidth(1);

    for ( int i = 0; i < QwtPlot::axisCnt; i++ )
    {
        QwtScaleWidget *scaleWidget = (QwtScaleWidget *)axisWidget(i);
        if ( scaleWidget )
            scaleWidget->setMargin(0);

        QwtScaleDraw *scaleDraw = (QwtScaleDraw *)axisScaleDraw(i);
        if ( scaleDraw )
            scaleDraw->enableComponent(QwtAbstractScaleDraw::Backbone, false);
    }

}


