#ifndef PLOT_H
#define PLOT_H

#include <qwt_plot.h>
#include <qwt_plot_marker.h>
#include <qwt_plot_curve.h>
#include <qwt_legend.h>
#include <qwt_data.h>
#include <qwt_text.h>
#include <qmainwindow.h>
#include <qwt_counter.h>
#include <qtoolbar.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qwt_plot.h>
#include <stdlib.h>
#include <qwt_painter.h>
#include <qwt_plot_curve.h>
#include <qwt_plot_canvas.h>
#include <qwt_scale_widget.h>
#include <qwt_scale_draw.h>
#include <qwt_math.h>
#include <qwt_plot_marker.h>
#include <qwt_plot_zoomer.h>
#include <qwt_scale_engine.h>
#include <qwt_legend.h>
#include <qwt_data.h>
#include <qwt_text.h>
#include <qwt_polygon.h>
#include <qregexp.h>
#include <qapplication.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qstatusbar.h>
#include <qprinter.h>
#include <qpicture.h>
#include <qpainter.h>
#include <qfiledialog.h>
#if QT_VERSION >= 0x040300
#ifdef QT_SVG_LIB
#include <qsvggenerator.h>
#endif
#endif
#if QT_VERSION >= 0x040000
#include <qprintdialog.h>
#include <qfileinfo.h>
#else
#include <qwt_painter.h>
#endif
#include <qwt_counter.h>
#include <qwt_plot_zoomer.h>
#include <qwt_plot_panner.h>
#include <qwt_text.h>
#include <qwt_math.h>
#include <qframe.h>
#include <qwt_scale_map.h>
#include <qwt_symbol.h>
#include <qcolor.h>
#include <qpaintengine.h>




class Plot : public QwtPlot
{

 public:
    Plot();

    void Init_Motors();
    void videPlot( );
    void abscisse( );
    void alignScales(); // mise en forme de la fenetre

    // stockage des valeurs de la position des membres
    double *val1; // mesure
    double *val4; // calcule degre 3
    double *val8; // calcul ident 3



    // creation des courbes
    QwtPlotCurve *courbe1; // les points des points de reference
    QwtPlotCurve *courbe4; // courbe degre 3
    QwtPlotCurve *courbe8; // les points des points ident 3



    // nombre de points a afficher
    int pointsAAfficherRef;
    int pointsAAfficherIdent;
    int pointsAAfficherIdent2;

    // stockage des valeurs de la variable
    double *stockVariable; 

    // stockage de l'axe des abscisses
    double *xPointsRef;
    double *xPointsIdent;
    double *xPointsIdent2;

    double valminY; // valeur minimum prise par la variable en ordonnee
    double valmaxY; // valeur maximum prise par la variable en ordonnee
    double valminX; // valeur minimum prise par la variable en abscisse
    double valmaxX; // valeur maximum prise par la variable en abscisse


};


class Zoomer: public QwtPlotZoomer
{
public:
    Zoomer(int xAxis, int yAxis, QwtPlotCanvas *canvas): QwtPlotZoomer(xAxis, yAxis, canvas)
    {

        setSelectionFlags(QwtPicker::DragSelection | QwtPicker::CornerToCorner);
        setTrackerMode(QwtPicker::AlwaysOff);
        setRubberBand(QwtPicker::NoRubberBand);

        // RightButton: zoom out by 1
        // Ctrl+RightButton: zoom out to full size
        setMousePattern(QwtEventPattern::MouseSelect2, Qt::RightButton, Qt::ControlModifier);
        setMousePattern(QwtEventPattern::MouseSelect3, Qt::RightButton);

    }
};



#endif

